// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"

#include <queue>

#include "AdventureCharacter.generated.h"

class AHexTile;

UCLASS()
class FRAY_API AAdventureCharacter : public ACharacter
{
	GENERATED_BODY()

public:
	// Sets default values for this character's properties
	AAdventureCharacter();

	UPROPERTY(VisibleInstanceOnly, BlueprintReadWrite, Category = "Runtime")
		AHexTile* GridLocation;
	UPROPERTY(VisibleInstanceOnly, BlueprintReadWrite, Category = "Runtime")
		AHexTile* SelectedHex;
	UPROPERTY(VisibleAnywhere, BlueprintReadWrite, Category = "Runtime")
		TArray<AHexTile*> MovementPath;
	UFUNCTION(BlueprintCallable)
		void AStarFindPath(AHexTile* Goal);

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	// Called to bind functionality to input
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

};
